package com.itsol.quantrivanphong.model;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.itsol.quantrivanphong.audit.DateAudit;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.data.jpa.domain.support.AuditingEntityListener;

import javax.persistence.*;

@Data
@NoArgsConstructor
@AllArgsConstructor
@Entity
@Table(name = "timesheet")
@EntityListeners(AuditingEntityListener.class)
@JsonIgnoreProperties(value = {"createdAt", "updatedAt"},
        allowGetters = true)

public class TimeSheet extends DateAudit {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id", nullable = false, unique = true)
    private int id;
// tiêu đề
    @Column(name = "title")
    private String title;
// nội dung
    @Column(name = "content")
    private String content;
// ghi chú
    @Column(name = "note")
    private String note;
// Duyệt, Chưa duyệt, Từ chối
    @Column(name = "checked")
    private String checked;
    // trạng thái
    @Column(name = "status")
    private boolean status;

    //    @JsonIgnore
    @ManyToOne(fetch = FetchType.EAGER)
    private Eproject eproject;
}
